# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib
#build with test jar
%bcond_without tests

%define repodir %{_javadir}/repository.jboss.com/jboss/cache/jbosscache-core/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}

Name:           jboss-cache-core
Version:        3.2.7
Release:        5.1%{?dist}
Epoch:          0
Summary:        JBoss Cache Core
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbosscache/core/tags/3.2.7.GA/ jboss-cache-core-3.2.7
# Exported revision 8456.
# tar cjf jboss-cache-core-3.2.7.tar.bz2 jboss-cache-core-3.2.7
Source0:        jboss-cache-core-3.2.7.tar.bz2
Source1:        jboss-cache-core-jpp-depmap.xml
Source2:        jboss-cache-core-settings.xml
# FIXME: We should have a package for the parent poms
Source3:	https://repository.jboss.org/nexus/content/repositories/releases/org/jboss/cache/jbosscache-common-parent/1.6/jbosscache-common-parent-1.6.pom
Source4:	https://repository.jboss.org/nexus/content/repositories/releases/org/jboss/cache/jbosscache-support/1.6/jbosscache-support-1.6.pom
Source5:	https://svn.jboss.org/repos/repository.jboss.org/maven2/org/jboss/cache/jbosscache-searchable/1.0.0.GA/jbosscache-searchable-1.0.0.GA.pom
Source6:        jboss-cache-core-component-info.xml
# Add dependency of qdox (with scope test)
Patch0:         jboss-cache-core-pom_xml.patch
# JBPAPP-6668 Include cache-jdbc.properties in jbosscache-core.jar
Patch1:         jboss-cache-core-pom_xml-jar.patch

Obsoletes:	jboss-cache < %{epoch}:%{version}-%{release}

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-dependency-plugin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
#BuildRequires:  maven-shared-enforcer-rule-api
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-testng
BuildRequires:  berkeleydb-je3
BuildRequires:  bsh2
BuildRequires:  c3p0
BuildRequires:  derby
BuildRequires:  easymock2
BuildRequires:  hsqldb
BuildRequires:  jakarta-commons-logging
BuildRequires:  jboss-common-core
BuildRequires:  jboss-parent
BuildRequires:  jboss-transaction-1.0.1-api
BuildRequires:  jbossts
BuildRequires:  jcip-annotations
BuildRequires:  jdbm
BuildRequires:  jgroups
BuildRequires:  noderunner-amazon-s3
BuildRequires:  noderunner-http
BuildRequires:  qdox >= 0:1.6.1
BuildRequires:  servlet_2_5_api
BuildRequires:  testng

Requires:  java >= 0:1.5.0
Requires:  jakarta-commons-logging
Requires:  jboss-common-core
Requires:  jgroups
Requires:  jboss-transaction-1.0.1-api

%description
JBoss cache core.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

# FIX pom.xml version
sed -i 's/${jbosscache-core-version}/%{namedversion}/g' pom.xml

%patch0 -p1
%patch1 -p1

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/
cp -p %{SOURCE3} $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/JPP-jbosscache-common-parent.pom
cp -p %{SOURCE4} $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/JPP-jbosscache-support.pom

MAVEN_OPTS="-Xmx1024m -Xms512m -XX:PermSize=64m -XX:MaxPermSize=1000m -XX:-UseGCOverheadLimit -XX:+HeapDumpOnOutOfMemoryError" export MAVEN_OPTS

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DskipExec=true \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -p -m 644 target/jbosscache-core.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
install -p -m 644 target/jbosscache-core-sources.jar %{buildroot}%{_javadir}/%{name}-sources-%{version}.jar
%if %with tests
install -p -m 644 target/jbosscache-core-tests.jar %{buildroot}%{_javadir}/%{name}-tests-%{version}.jar
ln -s %{name}-tests-%{version}.jar %{buildroot}%{_javadir}/jbosscache-core-tests-%{version}.jar
%endif
ln -s %{name}-%{version}.jar %{buildroot}%{_javadir}/jbosscache-core-%{version}.jar
ln -s %{name}-sources-%{version}.jar %{buildroot}%{_javadir}/jbosscache-core-sources-%{version}.jar
%add_to_maven_depmap org.jboss.cache jbosscache-core %{namedversion} JPP %{name}
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
%add_to_maven_depmap org.jboss.cache jbosscache-common-parent 1.6 JPP jbosscache-common-parent
install -p -m 644 %{SOURCE3} %{buildroot}%{_datadir}/maven2/poms/JPP-jbosscache-common-parent.pom
%add_to_maven_depmap org.jboss.cache jbosscache-support 1.6 JPP jbosscache-support
install -p -m 644 %{SOURCE4} %{buildroot}%{_datadir}/maven2/poms/JPP-jbosscache-support.pom
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom


# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* \
                  %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/jbosscache-core-%{version}
ln -s jbosscache-core-%{version} %{buildroot}%{_javadocdir}/jbosscache-core

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mvn-jpp deploy:deploy-file -e -DpomFile=%{SOURCE4} -DrepositoryId=maven2-brew \
    -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
    -Dfile=%{SOURCE4} 
mvn-jpp deploy:deploy-file -e -DpomFile=%{SOURCE3} -DrepositoryId=maven2-brew \
    -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
    -Dfile=%{SOURCE3}
sed -i 's/${jbosscache-searchable-version}/1.0.0.GA/g' %{SOURCE5}
mvn-jpp deploy:deploy-file -e -DpomFile=%{SOURCE5} -DrepositoryId=maven2-brew \
    -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
    -Dfile=%{SOURCE5} 

install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE6} %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE3} %{buildroot}%{repodirlib}/jbosscache-common-parent.pom
install -p -m 644 %{SOURCE4} %{buildroot}%{repodirlib}/jbosscache-support.pom
install -p -m 644 %{SOURCE5} %{buildroot}%{repodirlib}/jbosscache-searchable.pom
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/jbosscache-core.jar
install -p -m 644 pom.xml %{buildroot}%{repodirlib}/jbosscache-core.pom
cp -p %{buildroot}%{_javadir}/%{name}-sources-%{version}.jar %{buildroot}%{repodirlib}/jbosscache-core-sources.jar
%if %with tests
cp -p %{buildroot}%{_javadir}/%{name}-tests-%{version}.jar %{buildroot}%{repodirlib}/jbosscache-core-tests.jar
%endif
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/jboss-cache-core-%{version}.jar
%{_javadir}*/jboss-cache-core-sources-%{version}.jar
%{_javadir}*/jboss-cache-core-sources.jar
%if %with tests
%{_javadir}*/jboss-cache-core-tests-%{version}.jar
%{_javadir}*/jboss-cache-core-tests.jar
%endif
%{_javadir}*/jboss-cache-core.jar
%{_javadir}*/jbosscache-core-%{version}.jar
%{_javadir}*/jbosscache-core-sources-%{version}.jar
%{_javadir}*/jbosscache-core-sources.jar
%if %with tests
%{_javadir}*/jbosscache-core-tests-%{version}.jar
%{_javadir}*/jbosscache-core-tests.jar
%endif
%{_javadir}*/jbosscache-core.jar
%{_datadir}/maven2/poms/JPP-jboss-cache-core.pom
%{_datadir}/maven2/poms/JPP-jbosscache-common-parent.pom
%{_datadir}/maven2/poms/JPP-jbosscache-support.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}
%{_javadocdir}/jbosscache-core-%{version}
%{_javadocdir}/jbosscache-core

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Jun 06 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.2.7-5.1
- Add patch to include cache-jdbc.properties in jar

* Mon Mar 28 2011 Permaine Cheung <pcheung@redhat.com> - 0:3.2.7-5
- Rebuild with test jar (needed by jboss-cache-pojo)
- Add BR: qdox >= 0:1.6.1 (needed for tests)

* Tue Feb 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.2.7-4
- Remove references to qdox

* Wed Feb 18 2011 Yiqiao Wang <yiwang@redhat.com> - 0:3.2.7-3
- Add R: qdox >= 0:1.6.1

* Wed Feb 16 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.2.7-2
- Add all poms to maven2-brew
- Add extra memory parameters
- Add option to skip tests

* Tue Feb 15 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.2.7-1
- Upgrade to 3.2.7.GA

* Tue Feb 01 2011 Hui Wang <huwang@redhat.com> - 0:3.2.5-6
- Patch pom.xml
- Increase java memory
- Add maven.test.failure.ignore and remove maven.test.skip

* Fri Jan 14 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.2.5-5.2
- Fix release version in pom.xml

* Thu Jan 13 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.2.5-5.1
- Add maven.test.skip
- Add switch to include test jars when built

* Fri Nov 26 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.2.5-5
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-dependency-plugin, maven-deploy-plugin, maven-surefire-provider-testng

* Fri Jul 09 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.2.5-4
- Add Obsoletes jboss-cache

* Wed May 19 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.2.5-3
- Update pom.xml files for jbosscache-common-parent and jbosscache-support

* Tue May 18 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.2.5-2
- Add jbosscache-searchable pom.xml

* Wed May 17 2010 Luiz Barreiros <gbarreir@redhat.com> - 0:3.2.5-1
- Upgrade to 3.2.5.GA

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.2.2-2.1.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> 0:3.2.2-1
- Rebuild
- Add depmap entry for testng
- Fix depmep entry for jbossts

* Fri Jan 29 2010 Martha Benitez <mbenitez@redhat.com> 0:3.2.2-1
- Upgrade to 3.2.2.GA
- Add sources jar to main package and repolib

* Mon Jan 18 2010 David Walluck <dwalluck@redhat.com> 0:3.2.1-1.1
- BuildRequires: jboss-javaee-poms
- Add jboss-javaee-parent.pom as Source
- Fix depmap entries for jbossts
- Fix version for depmap entries of pom files

* Fri Oct 02 2009 David Walluck <dwalluck@redhat.com> 0:3.2.1-1
- 3.2.1

* Tue Aug 18 2009 Fernando Nasser <fnasser@redhat.com>  0:3.2.0-2
- Refresh source tar ball to eliminate SNAPSHOT

* Tue Aug 18 2009 Fernando Nasser <fnasser@redhat.com>  0:3.2.0-1
- Upgrade to 3.2.0.GA

* Mon Aug 17 2009 Fernando Nasser <fnasser@redhat.com>  0:3.2.0-0.1.CR1.1
- Upgrade to 3.2.0.CR1
- Add POM to repolib 

* Mon Aug 17 2009 Fernando Nasser <fnasser@redhat.com>  0:3.2.0-0.BETA2.1
- 3.2.0.BETA2

* Fri Aug 07 2009 David Walluck <dwalluck@redhat.com>  0:3.2.0-0.BETA1.1
- 3.2.0.BETA1
- change from jta_1_1_api to jboss-transaction-1.0.1-api as per 3.2.0.BETA1

* Thu Jul 02 2009 Martha Benitez <mbenitez@redhat.com> 0:3.1.0-3.1
- Change BR maven-shared-enforcer-rule-api to maven-enforcer-rule-api
- Change jbosscache-common-parent.pom location
- Change BR bsh2 to bsh

* Wed Jul 01 2009 David Walluck <dwalluck@redhat.com> 0:3.1.0-3
- fix repolib

* Tue Jun 30 2009 David Walluck <dwalluck@redhat.com> 0:3.1.0-2
- add repolib
- add compat symlinks

* Mon Jun 29 2009 Ralph Apel <r.apel@r-apel.de> - 0:3.1.0-1.jpp5
- 3.1.0.GA

* Mon Jun 15 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.2.0-1.jpp5
- first release
